diff -cNr ivtools-0.6.orig/PATCHLEVEL.JIV ivtools-0.6/PATCHLEVEL.JIV
*** ivtools-0.6.orig/PATCHLEVEL.JIV	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/PATCHLEVEL.JIV	Wed Jan 28 20:32:08 1998
***************
*** 0 ****
--- 1 ----
+ patch level: 4
diff -cNr ivtools-0.6.orig/config/InterViews/iv-linux.cf ivtools-0.6/config/InterViews/iv-linux.cf
*** ivtools-0.6.orig/config/InterViews/iv-linux.cf	Fri Feb 28 10:09:30 1997
--- ivtools-0.6/config/InterViews/iv-linux.cf	Wed Jan 28 23:37:10 1998
***************
*** 1,3 ****
--- 1,30 ----
+ /* Configuration for Linux				*/
+ /*	Thanks to noti@ssel.toshiba.co.jp		*/
+ /* $Id: iv-linux.cf,v 1.1 1994/02/27 08:14:57 tool Exp tool $ */
+ #define OSDefines -Dlinux -D_POSIX_SOURCE \
+ 		-D_BSD_SOURCE -D_SVID_SOURCE -DX_LOCALE
+ #define OSRelease
+ 
+ #include <x386.cf>
+ #include <InterViews/xparams.cf>
+ 
+ /*** if bug then dis-comment optimize(-O2) */
+ #undef  OptimizeCCFlags
+ #define OptimizeCCFlags -O
+ 
+ #undef  DebugCCFlags
+ #define DebugCCFlags
+ 
+ #ifndef TIFFCDriver
+ #define TIFFCDriver cc
+ #endif 
+ 
+ #ifndef TIFFOptimizeCFlags
+ #define TIFFOptimizeCFlags -O
+ #endif 
+ 
+ #undef SharedCCFlags
+ #define SharedCCFlags -fPIC -fshared-data
  /* 
   * This is the Linux configuration file for Interviews 3.1
   * Set up to use gcc in local.def
diff -cNr ivtools-0.6.orig/config/InterViews/iv-sun.cf ivtools-0.6/config/InterViews/iv-sun.cf
*** ivtools-0.6.orig/config/InterViews/iv-sun.cf	Fri Feb 28 10:09:32 1997
--- ivtools-0.6/config/InterViews/iv-sun.cf	Wed Jan 28 20:32:09 1998
***************
*** 17,22 ****
--- 17,27 ----
  
  /*
   * A bug in SunOS 4.1 causes dbx to crash if it tries to load an
+ 
+ /*
+  * if you use Sun C++ 2.1, define bellow
+  */
+ #define USE_SUNCxx2
   * application which uses a debuggable shared library, so we can't
   * have both debuggable and shareable libraries.
   */
diff -cNr ivtools-0.6.orig/config/params.def ivtools-0.6/config/params.def
*** ivtools-0.6.orig/config/params.def	Fri Jan 23 03:40:53 1998
--- ivtools-0.6/config/params.def	Wed Jan 28 20:32:09 1998
***************
*** 385,391 ****
  #endif
  
  #ifndef IvCCDefines
! #define IvCCDefines $(LANGUAGE_CCDEFINES) $(BACKWARD_CCDEFINES)
  #endif
  
  #ifndef LanguageCCDefines
--- 385,391 ----
  #endif
  
  #ifndef IvCCDefines
! #define IvCCDefines $(LANGUAGE_CCDEFINES) $(BACKWARD_CCDEFINES) $(JIV_CCDEFINES)
  #endif
  
  #ifndef LanguageCCDefines
***************
*** 396,401 ****
--- 396,405 ----
  #define BackwardCompatibilityCCDefines -Div2_6_compatible
  #endif
  
+ #ifndef JIVCCDefines
+ #define JapaneseIVCCDefines -DJIV -DPS_FIX -DJIV_EXTEND -DIV_FIX
+ #endif
+ 
  #ifndef ExtraCCDefines
  #if SystemV
  #define ExtraCCDefines -DSYSV
***************
*** 432,437 ****
--- 436,442 ----
         IV_CCDEFINES = IvCCDefines
   LANGUAGE_CCDEFINES = LanguageCCDefines
   BACKWARD_CCDEFINES = /* defined when Use_2_6() is used in Imakefile */
+       JIV_CCDEFINES = JapaneseIVCCDefines
      EXTRA_CCDEFINES = ExtraCCDefines
      OTHER_CCDEFINES = OtherCCDefines
  
diff -cNr ivtools-0.6.orig/config/site.def.LINUX ivtools-0.6/config/site.def.LINUX
*** ivtools-0.6.orig/config/site.def.LINUX	Tue Jan 27 02:14:58 1998
--- ivtools-0.6/config/site.def.LINUX	Fri Jan 30 00:24:57 1998
***************
*** 38,53 ****
   * Enable/disable relative InterViews-style installation of binaries
   */
  #undef InstallRelative
! #define InstallRelative YES
  
  /* 
  /* 
   * Where to put binaries, libraries, and data files when InstallRelative is NO
   */ 
  #if 1
! #define BinDir /usr/local/bin
! #define LibDir /usr/local/lib
! #define LibAllDir /usr/local/lib/ivtools
  #else
  #define InstalledRoot $(DESTDIR)/usr/X11R6 // for Debian
  #endif
--- 38,56 ----
   * Enable/disable relative InterViews-style installation of binaries
   */
  #undef InstallRelative
! #define InstallRelative NO
  
  /* 
  /* 
   * Where to put binaries, libraries, and data files when InstallRelative is NO
   */ 
  #if 1
! #define BinDir /usr/local/ivtools/bin
! #define LibDir /usr/local/ivtools/lib
! #define IncDir /usr/local/ivtools/include
! #define ManDir /usr/local/ivtools/man
! #define ConfigDir /usr/local/ivtools/config
! #define LibAllDir /usr/local/ivtools/share
  #else
  #define InstalledRoot $(DESTDIR)/usr/X11R6 // for Debian
  #endif
diff -cNr ivtools-0.6.orig/src/IV/Imakefile ivtools-0.6/src/IV/Imakefile
*** ivtools-0.6.orig/src/IV/Imakefile	Thu Dec 18 04:34:18 1997
--- ivtools-0.6/src/IV/Imakefile	Thu Jan 29 00:02:02 1998
***************
*** 20,25 ****
--- 20,30 ----
      $(DISPATCH)/iohandler.$(CCSUFFIX)
  #endif
  
+ #ifdef SharedCCFlags
+ #undef SharedCCFlags
+ #define SharedCCFlags -fPIC -fshared-data
+ #endif
+ 
  INTERVIEWS = $(SRC)/../InterViews
  IV_2_6	   = $(SRC)/../IV-2_6
  IV_X11	   = $(SRC)/../IV-X11
***************
*** 112,117 ****
--- 117,123 ----
  InterViewsObjFlags(tiff,$(OPTIMIZE_CCFLAGS))
  InterViewsObj(tformsetter)
  InterViewsObj(xymarker)
+ InterViewsObj(clthandler)
  
  #if BuildIV_2_6
  
***************
*** 187,192 ****
--- 193,201 ----
  IV_X11Obj(xreqerr)
  IV_X11Obj(xselection)
  IV_X11ObjFlags(xwindow,$(OPTIMIZE_CCFLAGS))
+ IV_X11ObjFlags(xjivfunc,$(OPTIMIZE_CCFLAGS))
+ IV_X11ObjFlags(kinput,$(OPTIMIZE_CCFLAGS))
+ IV_X11ObjFlags(convert,-DKANJI)
  
  #define DispatchObj(file) DispatchObjFlags(file,NullParameter)
  #define DispatchObjFlags(file,f) MakeObjectRule(file,$(DISPATCH)/file,f -xc++)
diff -cNr ivtools-0.6.orig/src/IV-2_6/filechooser.c ivtools-0.6/src/IV-2_6/filechooser.c
*** ivtools-0.6.orig/src/IV-2_6/filechooser.c	Wed Jan 21 10:01:57 1998
--- ivtools-0.6/src/IV-2_6/filechooser.c	Wed Jan 28 20:32:10 1998
***************
*** 23,28 ****
--- 23,31 ----
   */
  
  #include <InterViews/event.h>
+ #ifdef JIV_EXTEND
+ #include <IV-2_6/InterViews/world.h>			// for getLabel
+ #endif
  #include <IV-2_6/InterViews/adjuster.h>
  #include <IV-2_6/InterViews/border.h>
  #include <IV-2_6/InterViews/button.h>
***************
*** 43,48 ****
--- 46,59 ----
  #undef FileChooser
  #define FileChooser _lib_iv2_6(FileChooser)
  
+ #ifdef JIV_EXTEND
+ static const char* tmpLabel;
+ 
+ #define getLabel(attr, default) \
+     (((tmpLabel = World::current()->GetAttribute(attr)) != NULL) ? \
+      tmpLabel : default)
+ #endif
+ 
  FileChooser::FileChooser(
      const char* t, const char* subt, const char* d, 
      int r, int c, const char* acceptLabel, Alignment a
***************
*** 175,181 ****
--- 186,196 ----
              new HBox(
                  new VGlue(space, 0),
                  new HGlue,
+ #ifndef JIV_EXTEND
                  new PushButton("Cancel", state, '\007'),
+ #else
+                 new PushButton(getLabel("BCancel", "Cancel"), state, '\007'),
+ #endif
                  new HGlue(space, 0),
                  new PushButton(acptLbl, state, '\r')
              )
diff -cNr ivtools-0.6.orig/src/IV-2_6/interactor.c ivtools-0.6/src/IV-2_6/interactor.c
*** ivtools-0.6.orig/src/IV-2_6/interactor.c	Fri Feb 28 08:41:23 1997
--- ivtools-0.6/src/IV-2_6/interactor.c	Wed Jan 28 20:32:10 1998
***************
*** 74,79 ****
--- 74,82 ----
      managed_window = nil;
      cursor_ = nil;
      canvas_type_ = CanvasInputOutput;
+ #ifdef JIV		/* eto@ai.cs.fujitsu.co.jp 12 Jan 1992 */
+     cmhandler = nil;
+ #endif
      handler_ = new InteractorHandler(this);
      Resource::ref(handler_);
      ref();
***************
*** 584,586 ****
--- 587,601 ----
  CanvasType Interactor::GetCanvasType() const { return canvas_type_; }
  
  ManagedWindow* Interactor::GetTopLevelWindow() const { return managed_window; }
+ 
+ #ifdef JIV		/* eto@ai.cs.fujitsu.co.jp 12 Jan 1992 */
+ void Interactor::SetClientMessageHandler(ClientMessageHandler* h) {
+     cmhandler = h;
+ }
+ 
+ void Interactor::ResetClientMessageHandler(ClientMessageHandler* h) {
+     if (cmhandler == h) {
+ 	cmhandler = nil;
+     }
+ }
+ #endif
diff -cNr ivtools-0.6.orig/src/IV-2_6/sensor.c ivtools-0.6/src/IV-2_6/sensor.c
*** ivtools-0.6.orig/src/IV-2_6/sensor.c	Fri Feb 28 08:41:24 1997
--- ivtools-0.6/src/IV-2_6/sensor.c	Wed Jan 28 20:32:10 1998
***************
*** 30,35 ****
--- 30,38 ----
  
  extern unsigned long
      motionmask, keymask, entermask, leavemask, focusmask,
+ #ifdef JIV
+     propmask,
+ #endif /* JIV */
      upmask, downmask, initmask;
  
  Sensor::Sensor() {
***************
*** 75,80 ****
--- 78,86 ----
      allEvents->Catch(KeyEvent);
      allEvents->Catch(EnterEvent);
      allEvents->Catch(LeaveEvent);
+ #ifdef JIV
+     allEvents->Catch(PropertyEvent);
+ #endif /* JIV */
      onoffEvents = new Sensor;
      onoffEvents->Catch(EnterEvent);
      onoffEvents->Catch(LeaveEvent);
***************
*** 116,121 ****
--- 122,132 ----
  	case FocusOutEvent:
  	    mask |= focusmask;
  	    break;
+ #ifdef JIV
+ 	  case PropertyEvent:
+ 	    mask |= propmask;
+ 	    break;
+ #endif /* JIV */
      }
  }
  
***************
*** 175,180 ****
--- 186,196 ----
  	case FocusOutEvent:
  	    mask &= ~focusmask;
  	    break;
+ #ifdef JIV
+ 	  case PropertyEvent:
+ 	    mask &= ~propmask;
+ 	    break;
+ #endif /* JIV */
      }
  }
  
diff -cNr ivtools-0.6.orig/src/IV-2_6/textdisplay.c ivtools-0.6/src/IV-2_6/textdisplay.c
*** ivtools-0.6.orig/src/IV-2_6/textdisplay.c	Fri Feb 28 08:41:24 1997
--- ivtools-0.6/src/IV-2_6/textdisplay.c	Wed Jan 28 20:32:11 1998
***************
*** 50,55 ****
--- 50,58 ----
      void Replace(TextDisplay*, int line, const char*, int count);
  
      void Draw(TextDisplay*, int line, int first, int last);
+ #ifdef JIV
+     void DrawBeforeCharacter(TextDisplay*, int line, int next);
+ #endif
  
      int Index(TextDisplay*, IntCoord x, boolean between);
      IntCoord Offset(TextDisplay*, int index);
***************
*** 456,462 ****
--- 459,469 ----
  	caretline >= topline && caretline <= bottomline
      ) {
          TextLine* l = Line(caretline, true);
+ #ifndef JIV
          l->Draw(this, caretline, caretindex-1, caretindex);
+ #else	/* JIV */
+         l->DrawBeforeCharacter(this, caretline, caretindex);
+ #endif	/* JIV */
      }
  }
  
***************
*** 550,555 ****
--- 557,577 ----
      }
  }
  
+ #ifdef JIV
+ void TextDisplay::CaretPoint (
+   int&	x,
+   int&	y
+ ) {
+     IntCoord l = Left(caretline, caretindex);
+     IntCoord b = Base(caretline);
+     IntCoord nx, ny;
+ 
+     painter->MapCoord(canvas, l, b, nx, ny);
+     x = nx;
+     y = ny;
+ }
+ #endif
+ 
  TextLine::TextLine () {
      size = 0;
      text = nil;
***************
*** 580,588 ****
--- 602,623 ----
                      cw = 0;
                  }
              } else {
+ #ifndef JIV
                  cw = f->Width(text+i, 1);
+ #else
+ 		if ((unsigned char)text[i] < 0xa1) {
+ 		    cw = f->Width(text+i, 1);
+ 		} else {
+ 		    cw = f->Width(text+i, 2);
+ 		}
+ #endif
              }
              w += cw;
+ #ifdef JIV
+ 	    if ((unsigned char)text[i] >= 0xa1) {
+ 		i++;
+ 	    }
+ #endif
              ++i;
          }
          return w;
***************
*** 611,626 ****
--- 646,682 ----
                      cw = 0;
                  }
              } else {
+ #ifndef JIV
                  cw = f->Width(text+i, 1);
+ #else
+ 		if ((unsigned char)text[i] < 0xa1) {
+ 		    cw = f->Width(text+i, 1);
+ 		} else {
+ 		    cw = f->Width(text+i, 2);
+ 		}
+ #endif
              }
              w += cw;
              if (w > x) {
                  break;
              }
+ #ifdef JIV
+ 	    if ((unsigned char)text[i] >= 0xa1) {
+ 		i++;
+ 	    }
+ #endif
              ++i;
          }
          if (between && i <= lastchar && x > w - cw/2 || !between && x > w) {
+ #ifndef JIV
              return i+1;
+ #else
+ 	    if ((unsigned char)text[i] < 0xa1) {
+ 		return i+1;
+ 	    } else {
+ 		return i + 2;
+ 	    }
+ #endif
          } else {
              return i;
          }
***************
*** 676,681 ****
--- 732,746 ----
      int l = Math::min(last, lastchar);
      for (int i = f; i <= l; ++i) {
          attr[i] = attr[i] | style;
+ #ifdef JIV
+ 	if ((unsigned char)(text[i]) >= 0xa1) {
+ 	    if (i == last) {
+ 		last++;
+ 	    }
+ 	    i++;
+ 	    attr[i] = attr[i] | style;
+ 	}	    
+ #endif
      }
      Draw(display, line, first, last);
  }
***************
*** 693,698 ****
--- 758,772 ----
      int l = Math::min(last, lastchar);
      for (int i = f; i <= l; ++i) {
          attr[i] = attr[i] & ~st;
+ #ifdef JIV
+ 	if ((unsigned char)(text[i]) >= 0xa1) {
+ 	    if (i == last) {
+ 		last++;
+ 	    }
+ 	    i++;
+ 	    attr[i] = attr[i] & ~st;
+ 	}	    
+ #endif
      }
      Draw(display, line, first, last);
  }
***************
*** 793,798 ****
--- 867,884 ----
      Draw(display, line, -1, lastchar+1);
  }
  
+ #ifdef JIV
+ void TextLine::DrawBeforeCharacter (
+     TextDisplay* display, int line, int next
+ ) {
+     if ((unsigned char)(text[next - 1]) < 0xa1) {
+ 	Draw(display, line, next - 1, next);
+     } else {
+ 	Draw(display, line, next - 2, next);
+     }
+ }
+ #endif JIV
+ 
  void TextLine::Draw (
      TextDisplay* display, int line, int first, int last
  ) {
***************
*** 831,839 ****
                  }
              }
              int done = start;
              display->painter->MoveTo(left, bottom);
!             for (int i = start; i <= finish+1; ++i) {
!                 if (i==finish+1 || attr[i]!=attr[done] || text[i]=='\t') {
                      if (done != i && text[done] == '\t') {
                          IntCoord l, r, y;
                          display->painter->GetPosition(l, y);
--- 917,951 ----
                  }
              }
              int done = start;
+ #ifdef JIV
+ 	    boolean afterEuc = false;
+ 	    int tmpfinish = ((unsigned char)text[finish] < 0xa1 ?
+ 			     finish : finish + 1);
+ #endif
              display->painter->MoveTo(left, bottom);
!             for (int i = start;
! #ifndef JIV
! 		 i <= finish+1;
! #else
! 		 i <= tmpfinish+1;
! #endif
! 		 ++i) {
! #ifdef JIV
! 		if (afterEuc) {
! 		    afterEuc = false;
! 		    continue;
! 		}
! 		if ((unsigned char)text[i] >= 0xa1) {
! 		    afterEuc = true;
! 		}
! #endif
!                 if (
! #ifndef JIV
! 		    i==finish+1
! #else
! 		    i==tmpfinish+1
! #endif
! 		    || attr[i]!=attr[done] || text[i]=='\t') {
                      if (done != i && text[done] == '\t') {
                          IntCoord l, r, y;
                          display->painter->GetPosition(l, y);
diff -cNr ivtools-0.6.orig/src/IV-2_6/xevent2_6.c ivtools-0.6/src/IV-2_6/xevent2_6.c
*** ivtools-0.6.orig/src/IV-2_6/xevent2_6.c	Fri Feb 28 08:41:24 1997
--- ivtools-0.6/src/IV-2_6/xevent2_6.c	Wed Jan 28 20:32:11 1998
***************
*** 45,50 ****
--- 45,53 ----
  Mask upmask = ButtonReleaseMask|OwnerGrabButtonMask;
  Mask downmask = ButtonPressMask|OwnerGrabButtonMask;
  Mask initmask = PointerMotionHintMask;
+ #ifdef JIV
+ Mask propmask = PropertyChangeMask;
+ #endif /* JIV */
  
  boolean Sensor::Caught(const Event& e) const {
      XEvent& xe = e.rep()->xevent_;
***************
*** 65,70 ****
--- 68,78 ----
      case LeaveNotify:
  	return (mask & leavemask) != 0 &&
  	    e.rep()->xevent_.xcrossing.detail != NotifyInferior;
+ #ifdef JIV
+       case ClientMessage:
+       case PropertyNotify:
+ 	return (mask & propmask) != 0;
+ #endif /* JIV */
      }
      return false;
  }
***************
*** 99,104 ****
--- 107,120 ----
      case LeaveNotify:
  	GetCrossingInfo(LeaveEvent);
  	break;
+ #ifdef JIV
+       case ClientMessage:
+ 	eventType = ClientEvent;
+ 	break;
+       case PropertyNotify:
+ 	eventType = PropertyEvent;
+ 	break;
+ #endif JIV
      }
  }
  
diff -cNr ivtools-0.6.orig/src/IV-2_6/xinter.c ivtools-0.6/src/IV-2_6/xinter.c
*** ivtools-0.6.orig/src/IV-2_6/xinter.c	Wed Jan 21 09:28:00 1998
--- ivtools-0.6/src/IV-2_6/xinter.c	Wed Jan 28 20:32:12 1998
***************
*** 33,38 ****
--- 33,42 ----
  #include <InterViews/event.h>
  #include <InterViews/font.h>
  #include <InterViews/handler.h>
+ #ifdef JIV
+ /* patch for ClientMessage	12 Jan 1992 eto@ai.cs.fujitsu.co.jp */
+ #include <InterViews/clthandler.h>
+ #endif
  #include <InterViews/hit.h>
  #include <InterViews/style.h>
  #include <IV-2_6/InterViews/ihandler.h>
***************
*** 205,210 ****
--- 209,228 ----
   */
  
  Handler* InteractorWindow::target(const Event& e) const {
+ #ifdef JIV
+     /* patch for ClientMessage	10 Jan 1992 eto@ai.cs.fujitsu.co.jp */
+     int eventType = e.rep()->xevent_.type;
+     if ((eventType == ClientMessage) || (eventType == PropertyNotify)) {
+ 	ClientMessageHandler* h;
+ 	if ((h = interactor_->cmhandler) != nil) {
+ 	    if (h->handle_p(e)) {
+ 		return h;
+ 	    }
+ 	}
+ 	return nil;
+     }
+ #endif
+ 
      if (!e.rep()->has_pointer_location()) {
  	return nil;
      }
diff -cNr ivtools-0.6.orig/src/IV-2_6/xpainter.c ivtools-0.6/src/IV-2_6/xpainter.c
*** ivtools-0.6.orig/src/IV-2_6/xpainter.c	Wed Dec  3 02:30:28 1997
--- ivtools-0.6/src/IV-2_6/xpainter.c	Wed Jan 28 20:32:12 1998
***************
*** 52,57 ****
--- 52,60 ----
  #include <IV-X11/xpainter.h>
  #include <IV-X11/xpattern.h>
  #include <IV-X11/xraster.h>
+ #ifdef JIV
+ #include <IV-X11/xjivfunc.h>
+ #endif JIV
  #include <OS/list.h>
  #include <OS/math.h>
  #include <OS/string.h>
***************
*** 521,531 ****
--- 524,547 ----
      const Font* f, int c, int k, const Transformer& t
  ) {
      if (btable_ == nil) {
+ #ifndef JIV
          btable_ = new BitmapTable(256);
+ #else
+ 	btable_ = new BitmapTable(256 * 256);
+ #endif
          txtable_ = new BitmapTable(1024);
      }
      Bitmap* basic;
+ #ifndef JIV
      XFont fid = f->rep(display_)->font_->fid;
+ #else
+     XFont fid;
+     if (f->isComposite() && ((unsigned char)c > 0xff)) {
+ 	fid = f->rep2byte(display_)->font_->fid;
+     } else {
+ 	fid = f->rep(display_)->font_->fid;
+     }
+ #endif
      if (!btable_->find(basic, fid, c)) {
          basic = new Bitmap(f, c);
  	Resource::ref(basic);
***************
*** 817,834 ****
--- 833,883 ----
      if (txstring == 0) {
          Map(c, x, ybase - 1, x0, y0);
          if (rep->fillbg) {
+ #ifndef JIV
              XDrawImageString(
                  d, xid, rep->fillgc, x0, y0, s, len
              );
+ #else
+ 	    if (font->isComposite()) {
+ 		JIVDrawImageString(d, xid, rep->fillgc, font, x0, y0,
+ 			      (unsigned char*)s, len, Rep()->display);
+ 	    } else {
+ 		XDrawImageString(
+ 				 d, xid, rep->fillgc, x0, y0, s, len
+                 );
+ 	    }
+ #endif
          } else {
+ #ifndef JIV
              XDrawString(
                  d, xid, rep->fillgc, x0, y0, s, len
              );
+ #else
+ 	    if (font->isComposite()) {
+ 		JIVDrawString(d, xid, rep->fillgc, font, x0, y0,
+ 			      (unsigned char*)s, len, Rep()->display);
+ 	    } else {
+ 		XDrawString(
+ 			    d, xid, rep->fillgc, x0, y0, s, len
+ 		);
+ 	    }
+ #endif
          }
          if (style & Boldface) {
+ #ifndef JIV
              XDrawString(
                  d, xid, rep->fillgc, x0-1, y0, s, len
              );
+ #else
+ 	    if (font->isComposite()) {
+ 		JIVDrawString(d, xid, rep->fillgc, font, x0-1, y0,
+ 			      (unsigned char*)s, len, Rep()->display);
+ 	    } else {
+ 		XDrawString(
+ 			    d, xid, rep->fillgc, x0-1, y0, s, len
+ 		);
+ 	    }
+ #endif
          }
      } else {
          IntCoord curx = x;
***************
*** 848,853 ****
--- 897,903 ----
              switch (p.txfonts) {
              case PainterDpyInfo::TxFontsOff:
                  Map(c, curx, ybase - 1, x0, y0);
+ #ifndef JIV
                  XDrawString(
                      d, xid, rep->fillgc, x0, y0, s+i, 1
                  );
***************
*** 856,864 ****
--- 906,958 ----
                          d, xid, rep->fillgc, x0-1, y0, s+i, 1
                      );
                  }
+ #else
+ 		if (!font->isComposite()) {
+ 		    XDrawString(
+ 				d, xid, rep->fillgc, x0, y0, s + i, 1
+ 		    );
+ 		    if (style & Boldface) {
+ 			XDrawString(
+ 				    d, xid, rep->fillgc, x0-1, y0, s + i, 1
+ 			);
+ 		    }
+ 		} else if ((unsigned char)(*(s + i)) > 0x80) {
+ 		    JIVDrawString(d, xid, rep->fillgc, font, x0, y0,
+ 				  (unsigned char*)s + i, 2,
+ 				  Rep()->display);
+ 		    if (style & Boldface) {
+ 			JIVDrawString(d, xid, rep->fillgc, font,
+ 				      x0-1, y0,
+ 				      (unsigned char*)s + i, 2,
+ 				      Rep()->display);
+ 		    }
+ 		    i++;
+ 		} else {
+ 		    JIVDrawString(d, xid, rep->fillgc, font, x0, y0,
+ 				  (unsigned char*)s + i, 1,
+ 				  Rep()->display);
+ 		    if (style & Boldface) {
+ 			JIVDrawString(d, xid, rep->fillgc, font,
+ 				      x0-1, y0,
+ 				      (unsigned char*)s + i, 1,
+ 				      Rep()->display);
+ 		    }
+ 		}
+ #endif
                  break;
              case PainterDpyInfo::TxFontsOn:
+ #ifndef JIV
                  bits = new Bitmap(font, s[i]);
+ #else
+ 		if (font->isComposite() && ((unsigned char)(s[i]) >= 0xa1)) {
+ 		    int lc;
+ 		    lc = s[i] * 256 + s[i + 1];
+ 		    bits = new Bitmap(font, lc);
+ 		    i++;
+ 		} else {
+ 		    bits = new Bitmap(font, s[i]);
+ 		}
+ #endif
                  Stencil(c, curx, ybase, bits, bits);
                  if (style & Boldface) {
                      Stencil(c, curx-1, ybase, bits, bits);
***************
*** 866,872 ****
--- 960,978 ----
                  break;
              case PainterDpyInfo::TxFontsCache:
              case PainterDpyInfo::TxFontsDefault:
+ #ifndef JIV
                  bits = p.get_char_bitmap(font, s[i], txchar, notrans);
+ #else
+ 		if (font->isComposite() && ((unsigned char)(s[i]) >= 0xa1)) {
+ 		    unsigned int lc;
+ 		    lc = (unsigned char)s[i];
+ 		    lc = (lc << 8) | (unsigned char)s[i + 1];
+ 		    bits = p.get_char_bitmap(font, (int)lc, txchar, notrans);
+ 		    i++;
+ 		} else {
+ 		    bits = p.get_char_bitmap(font, s[i], txchar, notrans);
+ 		}
+ #endif
                  oldmatrix = matrix;
                  matrix = nil;
                  oldmatrix->Transform(curx, ybase, x0, y0);
***************
*** 1262,1267 ****
--- 1368,1392 ----
          XFreeGC(dpy, copygc);
      }
  }
+ 
+ #ifdef JIV
+ void Painter::MapCoord (
+   Canvas*	c,
+   IntCoord	x,
+   IntCoord	y,
+   IntCoord&	nx,
+   IntCoord&	ny
+ ) {
+     if (c == nil) {
+ 	return;
+     }
+     CanvasRep* cr = c->rep();
+     if (cr->xdrawable_ == CanvasRep::unbound) {
+ 	return;
+     }
+     Map(c, x, y, nx, ny);
+ }
+ #endif	/* JIV */
  
  /* anachronism */
  void CanvasRep::wait_for_copy() {
diff -cNr ivtools-0.6.orig/src/IV-X11/convert.c ivtools-0.6/src/IV-X11/convert.c
*** ivtools-0.6.orig/src/IV-X11/convert.c	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/src/IV-X11/convert.c	Wed Jan 28 20:32:12 1998
***************
*** 0 ****
--- 1,316 ----
+ /*
+  *	convert.c -- code converters for kterm
+  */
+ 
+ /*
+  * Copyright (c) 1989  Software Research Associates, Inc.
+  *
+  * Permission to use, copy, modify, and distribute this software and its
+  * documentation for any purpose and without fee is hereby granted, provided
+  * that the above copyright notice appear in all copies and that both that
+  * copyright notice and this permission notice appear in supporting
+  * documentation, and that the name of Software Research Associates not be
+  * used in advertising or publicity pertaining to distribution of the
+  * software without specific, written prior permission.  Software Research
+  * Associates makes no representations about the suitability of this software
+  * for any purpose.  It is provided "as is" without express or implied
+  * warranty.
+  *
+  * Author:  Makoto Ishisone, Software Research Associates, Inc., Japan
+  */
+ 
+ #ifdef JIV
+ 
+ #include <string.h>
+ 
+ #if defined(linux) && !defined(NULL)
+ #define NULL	0
+ #endif
+ 
+ #define SS2 0x8e
+ #define SS3 0x8f
+ 
+ static unsigned char* getesc(
+   unsigned char* str,
+   int len
+ ) {
+     register int	c;
+     
+     /* Find intermediate characters and final character
+      * following the escape character in an escape sequence.
+      */
+     /* The intermediate character is 02/00 to 02/15 */
+     while (len > 0) {
+ 	c = *str;
+ 	if (c < 0x20 || 0x2f < c)
+ 	    break;
+ 	len--, str++;
+     }
+     /* The final character is 03/00 to 07/14 */
+     if (--len < 0 || (c = *str++) < 0x30 || 0x7e < c)
+ 	return (unsigned char *)NULL;
+     
+     return str;
+ }
+ 
+ static unsigned char* getcsi(
+   unsigned char* str,
+   int len
+ ) {
+     register int	c;
+     
+     /* Find parameter characters, intermediate characters
+      * and final character following the CSI character
+      * in a CSI sequence.
+      */
+     /* The parameter characters is 03/00 to 03/15 */
+     while (len > 0) {
+ 	c = *str;
+ 	if (c < 0x30 || 0x3f < c)
+ 	    break;
+ 	len--, str++;
+     }
+     /* The intermediate character is 02/00 to 02/15 */
+     while (len > 0) {
+ 	c = *str;
+ 	if (c < 0x20 || 0x2f < c)
+ 	    break;
+ 	len--, str++;
+     }
+     /* The final character is 04/00 to 07/14 */
+     if (--len < 0 || (c = *str++) < 0x40 || 0x7e < c)
+ 	return (unsigned char *)NULL;
+     
+     return str;
+ }
+ 
+ /******************************************************************************
+ COMPOUND_TEXT Summary
+   (based on Comopund Text Encoding Version 1 -- MIT X Consortium Standard)
+ (1) Only G0 and G1 are used. G2 and G3 are not.
+ (2) G0 is invoked into GL and G1 into GR. These invocation are not changed.
+ 	(In other words, Locking Shift and Single Shift are not used)
+ (3) In initial state, ISO Latin-1 is designated into G0/G1.
+ (4) To designate MBCS into G0, ESC-$-F is not used but ESC-$-(-F.
+ (5) In C0, only HT, NL, and ESC are used.
+ (6) In C1, only CSI is used.
+ (7) Text direction can be indecated.
+ 	begin left-to-right string
+ 	begin right-to-left string
+ 	end of string
+ ******************************************************************************/
+ 
+ #define CS96	0x100	/* 96chars CS */
+ #define MBCS	0x200	/* Multibyte CS */
+ 
+ /* convCTtoEUC -- COMPOUND_TEXT -> Japanese EUC Character String */
+ int convCTtoEUC(
+   register unsigned char* xstr,
+   int len,
+   unsigned char* eucstr
+ /* Convert COMPOUND_TEXT xstr to EUC Character String wstr, return
+  * length of eucstr in characters (not including the terminating null
+  * character). If eucstr is NULL, no conversion is done, but return
+  * length of eucstr.
+  */
+ ) {
+     register int	c;
+     int	nskip;
+     int	n = 0;
+     int	g0, g1, gs;
+     unsigned char	*xstr1;
+     
+     /*
+      * Compound Text can include null octet. Therefore the length
+      * of xstr is able to be specified by parameter len.
+      * But if len is zero or negative, get length by strlen() assuming
+      * that no null octet exists.
+      */
+     if (len <= 0) {
+ 	len = strlen((char *)xstr);
+     }
+     
+     /* In initial state, ISO 8859/1 is designated into G0/G1 */
+     g0 = 'B';			/* ASCII -> G0 */
+     g1 = CS96|'A';		/* Latin/1 right hand part -> G1 */
+     
+     while (len-- > 0) {
+ 	switch (c = *xstr++) {
+ 	  case '\n':		/* NEWLINE */
+ 	  case '\t':		/* TAB */
+ 	    if (eucstr) *eucstr++ = c;
+ 	    n++;
+ 	    break;
+ 	  case 0x9b:		/* CSI */
+ 	    /*
+ 	     * CSI sequence is generally in following form:
+ 	     *	CSI {P} {I} F
+ 	     *        P : 03/00 to 03/15
+ 	     *        I : 02/00 to 02/15
+ 	     *        F : 04/00 to 07/14
+ 	     */
+ 	    /*
+ 	     * Currently only directionality is definde
+ 	     * as following:
+ 	     *	CSI-1-]		begin left-to-right text
+ 	     *	CSI-2-]		begin right-to-left text
+ 	     *	CSI-]		end of string
+ 	     * But this implementation ignores them.
+ 	     */
+ 	    xstr1 = getcsi(xstr, len);
+ 	    if (xstr1 == NULL)
+ 		return -1;
+ 	    len -= xstr1 - xstr;
+ 	    xstr = xstr1;
+ 	    break;
+ 	  case '\033':		/* ESC */
+ 	    /*
+ 	     * ESC sequence is generally in following form:
+ 	     *	ESC {I} F
+ 	     *        I : 02/00 to 02/15
+ 	     *        F : 03/00 to 07/14
+ 	     */
+ 	    /*
+ 	     * Currently, following functions are defined:
+ 	     *   Standard character set
+ 	     *	ESC-(-F
+ 	     *	ESC-$-(-F
+ 	     *	ESC-)-F
+ 	     *	ESC---F
+ 	     *	ESC-$-)-F
+ 	     *   Non standard character set
+ 	     *	ESC-%-/-[0123]
+ 	     * Standard character set must be accepted correctly.
+ 	     * Non standard one is ignored but must be parsed
+ 	     * for skipping data.
+ 	     */
+ 	    xstr1 = getesc(xstr, len);
+ 	    if (xstr1 == NULL)
+ 		return -1;
+ 	    len -= xstr1 - xstr;
+ 	    switch (xstr1 - xstr) {
+ 	      case 2:		/* ESC - I - F */
+ 		switch (*xstr++) {
+ 		  case '(':	/* 94chars CS -> G0 */
+ 		    g0 = *xstr;
+ 		    break;
+ 		  case ')':	/* 94chars CS -> G1 */
+ 		    g1 = *xstr;
+ 		    break;
+ 		  case '-':	/* 96chars CS -> G1 */
+ 		    g1 = *xstr | CS96;
+ 		    break;
+ 		  default:	/* ignore */
+ 		    break;
+ 		}
+ 		break;
+ 	      case 3:		/* ESC - I - I - F */
+ 		switch (*xstr++) {
+ 		  case '$':
+ 		    switch (*xstr++) {
+ 		      case '(':	/* 94chars MBCS -> G0 */
+ 			g0 = *xstr | MBCS;
+ 			break;
+ 		      case ')':	/* 94chars MBCS -> G1 */
+ 			g1 = *xstr | MBCS;
+ 			break;
+ 		      case '-':	/* 96chars MBCS -> G1 */
+ 			g1 = *xstr | CS96 | MBCS;
+ 			break;
+ 		      default:	/* ignore */
+ 			break;
+ 		    }
+ 		    break;
+ 		  case '%':
+ 		    if (*xstr++ != '/') {
+ 			/* unknown sequence */
+ 			break;
+ 		    }
+ 		    /*
+ 		     * Private encoding is ignored.
+ 		     * But following data must be skipped.
+ 		     *	ESC-%-/-F-M-L
+ 		     */
+ 		    len -= 2;
+ 		    if (len < 0)
+ 			return -1;
+ 		    nskip = (*xstr1 & 0x7f) * 128 +
+ 			(*(xstr1 + 1) & 0x7f);
+ 		    if ((len -= nskip) < 0)
+ 			return -1;
+ 		    xstr1 += nskip + 2;
+ 		    break;
+ 		  default:
+ 		    break;
+ 		}
+ 		break;
+ 	      default:
+ 		break;
+ 	    }
+ 	    xstr = xstr1;
+ 	    break;
+ 	  default:
+ 	    if (!(c & 0x60)) {
+ 		/*
+ 		 * Non NL/TAB/ESC/CSI character in C0 or C1
+ 		 * is an obvious error.
+ 		 */
+ 		return -1;
+ 	    }
+ 	    gs = (c & 0x80) ? g1 : g0;
+ 	    c &= 0x7f;
+ 	    if (gs & MBCS) {
+ 		switch (gs & 0x70) {
+ 		  case 0x70:	/* 4byte/char */
+ 		    if (--len < 0) return -1;
+ 		    c = (c << 8) | (*xstr++ & 0x7f);
+ 		  case 0x60:	/* 3byte/char */
+ 		    if (--len < 0) return -1;
+ 		    c = (c << 8) | (*xstr++ & 0x7f);
+ 		  case 0x50:	/* 2byte/char */
+ 		  case 0x40:	/* 2byte/char */
+ 		    if (--len < 0) return -1;
+ 		    c = (c << 8) | (*xstr++ & 0x7f);
+ 		    break;
+ 		  default:
+ 		    return -1;
+ 		}
+ 	    }
+ 	    if (eucstr) {
+ 		switch (gs) {
+ 		  case 'B':
+ 		  case 'J':
+ 		    *eucstr++ = c;
+ 		    n++;
+ 		    break;
+ 		  case 'I':
+ 		    *eucstr++ = SS2;
+ 		    *eucstr++ = c;
+ 		    n += 2;
+ 		    break;
+ 		  case MBCS|'B':
+ 		    *eucstr++ = (c >> 8) | 0x80;
+ 		    *eucstr++ = (c & 0xff) | 0x80;
+ 		    n += 2;
+ 		    break;
+ 		}
+ 	    } else {
+ 		switch (gs) {
+ 		  case 'B':
+ 		  case 'J':
+ 		    n++;
+ 		    break;
+ 		  case 'I':
+ 		  case MBCS|'B':
+ 		    n += 2;
+ 		    break;
+ 		}
+ 	    }
+ 	    break;
+ 	}
+     }
+     if (eucstr) *eucstr = 0;
+     return n;
+ }
+ 
+ #endif /* JIV */
